"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.convertSwaggerFile = void 0;

var _swagger2openapi = _interopRequireDefault(require("swagger2openapi"));

var _jsYaml = _interopRequireDefault(require("js-yaml"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Import and parse the openapi spec from a yaml/json
 */
const convertSwaggerFile = (data, extension) => {
  const schema = extension === 'yaml' ? _jsYaml.default.load(data) : JSON.parse(data);
  return new Promise((resolve, reject) => {
    if (!schema.openapi || !schema.openapi.startsWith('3.')) {
      _swagger2openapi.default.convertObj(schema, {}, (err, convertedObj) => {
        if (err) {
          reject(err);
        } else {
          // @ts-ignore
          convertedObj.openapi.basePath = convertedObj.original.basePath;
          resolve(convertedObj.openapi);
        }
      });
    } else {
      resolve(schema);
    }
  });
};

exports.convertSwaggerFile = convertSwaggerFile;
//# sourceMappingURL=convertSwaggerFile.js.map