"use strict";
exports.__esModule = true;
exports.convertSwaggerFile = void 0;
var swagger2openapi_1 = require("swagger2openapi");
var js_yaml_1 = require("js-yaml");
/**
 * Import and parse the openapi spec from a yaml/json
 */
var convertSwaggerFile = function (data, extension) {
    var schema = extension === 'yaml' ? js_yaml_1["default"].load(data) : JSON.parse(data);
    return new Promise(function (resolve, reject) {
        if (!schema.openapi || !schema.openapi.startsWith('3.')) {
            swagger2openapi_1["default"].convertObj(schema, {}, function (err, convertedObj) {
                if (err) {
                    reject(err);
                }
                else {
                    // @ts-ignore
                    convertedObj.openapi.basePath = convertedObj.original.basePath;
                    resolve(convertedObj.openapi);
                }
            });
        }
        else {
            resolve(schema);
        }
    });
};
exports.convertSwaggerFile = convertSwaggerFile;
