"use strict";
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.generateImports = void 0;
var generateImports = function (_a) {
    var schemaName = _a.schemaName, apiDirectory = _a.apiDirectory, queryClientDir = _a.queryClientDir, schemaImports = _a.schemaImports, queryImports = _a.queryImports;
    var importTypes = schemaImports.join(',');
    var imports = [];
    if (queryImports.includes('query')) {
        imports = __spreadArray(__spreadArray([], imports, true), ['useQuery', 'UseQueryOptions', 'QueryKey', 'SetDataOptions', 'QueryFilters'], false);
    }
    if (queryImports.includes('infiniteQuery')) {
        imports = __spreadArray(__spreadArray([], imports, true), ['useInfiniteQuery', 'UseInfiniteQueryOptions', 'QueryKey'], false);
    }
    if (queryImports.includes('mutation')) {
        imports = __spreadArray(__spreadArray([], imports, true), ['UseMutationOptions', 'useMutation'], false);
    }
    var importString = __spreadArray([], new Set(imports), true).join(',');
    return "\n  import {\n    ".concat(importString, "\n  } from '@tanstack/react-query';\n  \n  import { AxiosError } from 'axios';\n  import { api } from '").concat(apiDirectory, "';\n  import { queryClient } from '").concat(queryClientDir, "';\n\n  import {").concat(importTypes, "} from './").concat(schemaName, "'\n\n  type Updater<TInput, TOutput> = TOutput | ((input: TInput) => TOutput);  \n  ");
};
exports.generateImports = generateImports;
