"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
exports.importSpecs = void 0;
var chalk_1 = require("chalk");
var fs_1 = require("fs");
var path_1 = require("path");
var convertSwaggerFile_js_1 = require("./convertSwaggerFile.js");
var generateHooks_js_1 = require("./generateHooks.js");
var generateImports_js_1 = require("./generateImports.js");
var generateSchemas_js_1 = require("./generateSchemas.js");
function importSpecs(_a) {
    var sourceDirectory = _a.sourceDirectory, exportDirectory = _a.exportDirectory, apiDirectory = _a.apiDirectory, queryClientDir = _a.queryClientDir, headerFilters = _a.headerFilters, overrides = _a.overrides;
    (0, fs_1.readdir)(sourceDirectory, function (err, filenames) {
        var _this = this;
        if (err) {
            console.log(err);
            throw err;
        }
        filenames.map(function (filename) { return __awaiter(_this, void 0, void 0, function () {
            var data, ext, format, spec_1, schemaName, hooksName, name_1, operationIds_1, hooks_1, schemaImportsArray_1, collectedQueryImports_1, imports, schemas, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        data = (0, fs_1.readFileSync)((0, path_1.join)(process.cwd(), sourceDirectory + '/' + filename), 'utf-8');
                        ext = (0, path_1.parse)(sourceDirectory + '/' + filename).ext;
                        format = ['.yaml', '.yml'].includes(ext.toLowerCase()) ? 'yaml' : 'json';
                        return [4 /*yield*/, (0, convertSwaggerFile_js_1.convertSwaggerFile)(data, format)];
                    case 1:
                        spec_1 = _a.sent();
                        schemaName = "useQueries".concat(filename.split('.')[0], ".schema");
                        hooksName = "useQueries".concat(filename.split('.')[0]);
                        name_1 = filename.split('.')[0];
                        (0, fs_1.mkdirSync)((0, path_1.join)(process.cwd(), "".concat(exportDirectory, "/").concat(name_1)), { recursive: true });
                        operationIds_1 = [];
                        hooks_1 = '';
                        schemaImportsArray_1 = [];
                        collectedQueryImports_1 = [];
                        Object.entries(spec_1.paths).forEach(function (_a) {
                            var route = _a[0], verbs = _a[1];
                            Object.entries(verbs).forEach(function (_a) {
                                var verb = _a[0], operation = _a[1];
                                if (['get', 'post', 'patch', 'put', 'delete'].includes(verb) && !operation.deprecated) {
                                    var _b = (0, generateHooks_js_1.createHook)({
                                        operation: operation,
                                        verb: verb,
                                        route: (spec_1.basePath || '') + route,
                                        operationIds: operationIds_1,
                                        parameters: verbs.parameters,
                                        schemasComponents: spec_1.components,
                                        headerFilters: headerFilters,
                                        overrides: overrides
                                    }), implementation = _b.implementation, imports_1 = _b.imports, queryImports = _b.queryImports;
                                    hooks_1 += implementation;
                                    imports_1.forEach(function (element) {
                                        var formattedImport = element.replace('[]', '');
                                        if (!schemaImportsArray_1.includes(formattedImport) &&
                                            element !== 'void' &&
                                            element !== 'string' &&
                                            !element.includes('{')) {
                                            schemaImportsArray_1.push(formattedImport);
                                        }
                                    });
                                    queryImports.forEach(function (element) {
                                        if (!schemaImportsArray_1.includes(element)) {
                                            collectedQueryImports_1.push(element);
                                        }
                                    });
                                }
                            });
                        });
                        imports = (0, generateImports_js_1.generateImports)({
                            apiDirectory: apiDirectory,
                            queryClientDir: queryClientDir,
                            schemaName: schemaName,
                            schemaImports: schemaImportsArray_1,
                            queryImports: collectedQueryImports_1
                        });
                        (0, fs_1.writeFileSync)((0, path_1.join)(process.cwd(), "".concat(exportDirectory, "/").concat(name_1, "/").concat(hooksName, ".tsx")), imports + hooks_1);
                        schemas = (0, generateSchemas_js_1.generateSchemas)({ spec: spec_1 });
                        (0, fs_1.writeFileSync)((0, path_1.join)(process.cwd(), "".concat(exportDirectory, "/").concat(name_1, "/").concat(schemaName, ".tsx")), schemas);
                        console.log(chalk_1["default"].green("\uD83C\uDF89 [".concat(filename, "] Your OpenAPI spec has been converted into react query hooks")));
                        return [3 /*break*/, 3];
                    case 2:
                        error_1 = _a.sent();
                        if (error_1.code === 'EISDIR') {
                            console.log(chalk_1["default"].red('nested folder structure not supported'));
                            return [2 /*return*/];
                        }
                        console.log(chalk_1["default"].red("[".concat(filename, "]:")), chalk_1["default"].red(error_1));
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        }); });
    });
}
exports.importSpecs = importSpecs;
